#ifndef _ACTION_H
#define _ACTION_H

#include <pthread.h>
#include <client_handler.h>
#include "object.h"

class Druid;

class Background {
    Druid& act;
    double displace;
    double last;
    double period;
    double maximal;
    double same;
    double value;
    unsigned int errcount;
    static const int max_count = 3;
public:
    Background( Config&, Druid& );
    void run_checked();
    void run_nochecked();
    bool disable_same();
    bool needed();
    double get() { return value; }
private:
    void measure();
};

class Druid {
    std::auto_ptr<ClientHandler> dimm;
    std::auto_ptr<ClientHandler> mass;
    std::auto_ptr<ClientHandler> tlsp;
    Background background;
    unsigned int settle_time;
    unsigned int errcount;
    double focus;
    double separation;
    double sep_tolrn;
    double work_zone;
    double mass_mag_ext;
    double star_flux_d;
    unsigned int errflux;
    std::vector<double> mass_mag_set;
    friend class Background;
    bool mass_enable;
    double guide_last;
public:
    Druid( Config& );
    ~Druid();
    bool point_star( const ObjectInfo& );
    bool check_star( const ObjectInfo& );
    bool check_status( const ObjectInfo& );
    bool no_check_status( const ObjectInfo& );
    bool check_flux();
    bool measurement();
    bool dimm_measurement();
    bool beginning();
    bool photo_stability();
    void regime( const std::string& );
private:
    bool center_star(  const ObjectInfo& );
    bool init();
    bool park( ClientHandler* );
    void focusing( double );
    bool focus_dimm();
    double check_separation();
    bool stop_guiding();
    bool start_guiding();
    bool start_dimm_guiding();
    bool check_mass_mag( const ObjectInfo&, double );
    bool mass_usage( bool );
    void camera( const std::string& );
    bool mass_off();
};

#endif
